diff -aburN --exclude='CVS*' phpgwapi.org/templates/default/navbar.inc.php phpgwapi/templates/default/navbar.inc.php
--- phpgwapi.org/templates/default/navbar.inc.php	2004-11-06 16:34:25.000000000 +0100
+++ phpgwapi/templates/default/navbar.inc.php	2005-09-30 20:44:37.972323200 +0200
@@ -90,15 +90,27 @@
 
 		// Maybe we should create a common function in the phpgw_accounts_shared.inc.php file
 		// to get rid of duplicate code.
+		if ($GLOBALS['phpgw']->acl->get_rights('changepassword','preferences') > 0)
+		{
 		if ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] == 0)
 		{
 			$api_messages = lang('You are required to change your password during your first login')
-				. '<br /> Click this image on the navbar: <img src="'
-				. $GLOBALS['phpgw']->common->image('preferences','navbar.gif').'">';
+                	     . '<br /> Click <a href="' . $GLOBALS['phpgw']->link('/preferences/changepassword.php') . '">here</a>';
+ 			}
+			else if ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] < time() - (86400*30))
+			{
+				$api_messages = lang('it has been more then %1 days since you changed your password',30)
+                	     . '<br /> Click <a href="' . $GLOBALS['phpgw']->link('/preferences/changepassword.php') . '">' . lang('here') . '</a>';
 		}
-		elseif ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] < time() - (86400*30))
+
+			if($api_messages)
 		{
-			$api_messages = lang('it has been more then %1 days since you changed your password',30);
+				$url = parse_url($GLOBALS['phpgw']->link('/preferences/changepassword.php'));
+				if($_SERVER['PHP_SELF'] != $url['path'])
+				{
+					$var['messages'] = $api_messages;
+				}
+			}
 		}
  
 		// This is gonna change
diff -aburN --exclude='CVS*' phpgwapi.org/templates/desktop/navbar.inc.php phpgwapi/templates/desktop/navbar.inc.php
--- phpgwapi.org/templates/desktop/navbar.inc.php	2005-02-27 00:05:53.000000000 +0100
+++ phpgwapi/templates/desktop/navbar.inc.php	2005-09-30 20:44:37.862164800 +0200
@@ -127,15 +127,27 @@
 
 		// Maybe we should create a common function in the phpgw_accounts_shared.inc.php file
 		// to get rid of duplicate code.
+		if ($GLOBALS['phpgw']->acl->get_rights('changepassword','preferences') > 0)
+		{
 		if ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] == 0)
 		{
 			$api_messages = lang('You are required to change your password during your first login')
-				. '<br /> Click this image on the navbar: <img src="'
-				. $GLOBALS['phpgw']->common->image('preferences','navbar.gif').'">';
+                	     . '<br /> Click <a href="' . $GLOBALS['phpgw']->link('/preferences/changepassword.php') . '">here</a>';
+ 			}
+			else if ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] < time() - (86400*30))
+			{
+				$api_messages = lang('it has been more then %1 days since you changed your password',30)
+                	     . '<br /> Click <a href="' . $GLOBALS['phpgw']->link('/preferences/changepassword.php') . '">' . lang('here') . '</a>';
 		}
-		elseif ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] < time() - (86400*30))
+
+			if($api_messages)
 		{
-			$api_messages = lang('it has been more then %1 days since you changed your password',30);
+				$url = parse_url($GLOBALS['phpgw']->link('/preferences/changepassword.php'));
+				if($_SERVER['PHP_SELF'] != $url['path'])
+				{
+					$var['messages'] = $api_messages;
+				}
+			}
 		}
  
 		// This is gonna change
diff -aburN --exclude='CVS*' phpgwapi.org/templates/idots/navbar.inc.php phpgwapi/templates/idots/navbar.inc.php
--- phpgwapi.org/templates/idots/navbar.inc.php	2004-11-06 16:34:27.000000000 +0100
+++ phpgwapi/templates/idots/navbar.inc.php	2005-09-30 20:44:37.782049600 +0200
@@ -95,15 +95,27 @@
 		. lang($GLOBALS['phpgw']->common->show_date($now,'l')) . ' '
 		. $GLOBALS['phpgw']->common->show_date($now,$GLOBALS['phpgw_info']['user']['preferences']['common']['dateformat']);
 
+		if ($GLOBALS['phpgw']->acl->get_rights('changepassword','preferences') > 0)
+		{
 		if ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] == 0)
 		{
 			$api_messages = lang('You are required to change your password during your first login')
-			. '<br /> Click this image on the navbar: <img src="'
-			. $GLOBALS['phpgw']->common->image('preferences','navbar.gif').'">';
+                	     . '<br /> Click <a href="' . $GLOBALS['phpgw']->link('/preferences/changepassword.php') . '">here</a>';
 		}
 		else if ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] < time() - (86400*30))
 		{
-			$api_messages = lang('it has been more then %1 days since you changed your password',30);
+				$api_messages = lang('it has been more then %1 days since you changed your password',30)
+                	     . '<br /> Click <a href="' . $GLOBALS['phpgw']->link('/preferences/changepassword.php') . '">' . lang('here') . '</a>';
+			}
+
+			if($api_messages)
+			{
+				$url = parse_url($GLOBALS['phpgw']->link('/preferences/changepassword.php'));
+				if($_SERVER['PHP_SELF'] != $url['path'])
+				{
+					$var['messages'] = $api_messages;
+				}
+			}
 		}
 
 		// This is gonna change
diff -aburN --exclude='CVS*' phpgwapi.org/templates/idsociety/navbar.inc.php phpgwapi/templates/idsociety/navbar.inc.php
--- phpgwapi.org/templates/idsociety/navbar.inc.php	2004-11-06 16:34:27.000000000 +0100
+++ phpgwapi/templates/idsociety/navbar.inc.php	2005-09-30 20:44:37.741992000 +0200
@@ -182,15 +182,27 @@
 
 		// Maybe we should create a common function in the phpgw_accounts_shared.inc.php file
 		// to get rid of duplicate code.
+		if ($GLOBALS['phpgw']->acl->get_rights('changepassword','preferences') > 0)
+		{
 		if ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] == 0)
 		{
 			$api_messages = lang('You are required to change your password during your first login')
-				. '<br /> Click this image on the navbar: <img src="'
-				. $GLOBALS['phpgw']->common->image('preferences','navbar.gif').'">';
+                	     . '<br /> Click <a href="' . $GLOBALS['phpgw']->link('/preferences/changepassword.php') . '">here</a>';
+ 			}
+			else if ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] < time() - (86400*30))
+			{
+				$api_messages = lang('it has been more then %1 days since you changed your password',30)
+                	     . '<br /> Click <a href="' . $GLOBALS['phpgw']->link('/preferences/changepassword.php') . '">' . lang('here') . '</a>';
 		}
-		elseif ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] < time() - (86400*30))
+
+			if($api_messages)
 		{
-			$api_messages = lang('it has been more then %1 days since you changed your password',30);
+				$url = parse_url($GLOBALS['phpgw']->link('/preferences/changepassword.php'));
+				if($_SERVER['PHP_SELF'] != $url['path'])
+				{
+					$var['messages'] = $api_messages;
+				}
+			}
 		}
  
 		// This is gonna change
diff -aburN --exclude='CVS*' phpgwapi.org/templates/justweb/navbar.inc.php phpgwapi/templates/justweb/navbar.inc.php
--- phpgwapi.org/templates/justweb/navbar.inc.php	2004-11-06 16:34:27.000000000 +0100
+++ phpgwapi/templates/justweb/navbar.inc.php	2005-09-30 20:44:37.701934400 +0200
@@ -75,15 +75,27 @@
 		 * to get rid of duplicate code.
 		 */
 
+		if ($GLOBALS['phpgw']->acl->get_rights('changepassword','preferences') > 0)
+		{
 		if ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] == 0)
 		{
 			$api_messages = lang('You are required to change your password during your first login')
-				. '<br /> Click this image on the navbar: <img src="'
-				. $GLOBALS['phpgw']->common->image('preferences','navbar.gif').'">';
+                	     . '<br /> Click <a href="' . $GLOBALS['phpgw']->link('/preferences/changepassword.php') . '">here</a>';
+ 			}
+			else if ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] < time() - (86400*30))
+			{
+				$api_messages = lang('it has been more then %1 days since you changed your password',30)
+                	     . '<br /> Click <a href="' . $GLOBALS['phpgw']->link('/preferences/changepassword.php') . '">' . lang('here') . '</a>';
 		}
-		elseif ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] < time() - (86400*30))
+
+			if($api_messages)
 		{
-			$api_messages = lang('it has been more then %1 days since you changed your password',30);
+				$url = parse_url($GLOBALS['phpgw']->link('/preferences/changepassword.php'));
+				if($_SERVER['PHP_SELF'] != $url['path'])
+				{
+					$var['messages'] = $api_messages;
+				}
+			}
 		}
  
 		// This is gonna change
diff -aburN --exclude='CVS*' phpgwapi.org/templates/linux-at-work.de/navbar.inc.php phpgwapi/templates/linux-at-work.de/navbar.inc.php
--- phpgwapi.org/templates/linux-at-work.de/navbar.inc.php	2004-11-06 16:34:27.000000000 +0100
+++ phpgwapi/templates/linux-at-work.de/navbar.inc.php	2005-09-30 20:44:37.641848000 +0200
@@ -102,15 +102,27 @@
 
 		// Maybe we should create a common function in the phpgw_accounts_shared.inc.php file
 		// to get rid of duplicate code.
+		if ($GLOBALS['phpgw']->acl->get_rights('changepassword','preferences') > 0)
+		{
 		if ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] == 0)
 		{
 			$api_messages = lang('You are required to change your password during your first login')
-				. '<br /> Click this image on the navbar: <img src="'
-				. $GLOBALS['phpgw']->common->image('preferences','navbar.gif').'">';
+                	     . '<br /> Click <a href="' . $GLOBALS['phpgw']->link('/preferences/changepassword.php') . '">here</a>';
+ 			}
+			else if ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] < time() - (86400*30))
+			{
+				$api_messages = lang('it has been more then %1 days since you changed your password',30)
+                	     . '<br /> Click <a href="' . $GLOBALS['phpgw']->link('/preferences/changepassword.php') . '">' . lang('here') . '</a>';
 		}
-		elseif ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] < time() - (86400*30))
+
+			if($api_messages)
 		{
-			$api_messages = lang('it has been more then %1 days since you changed your password',30);
+				$url = parse_url($GLOBALS['phpgw']->link('/preferences/changepassword.php'));
+				if($_SERVER['PHP_SELF'] != $url['path'])
+				{
+					$var['messages'] = $api_messages;
+				}
+			}
 		}
  
 		// This is gonna change
diff -aburN --exclude='CVS*' phpgwapi.org/templates/probusiness/navbar.inc.php phpgwapi/templates/probusiness/navbar.inc.php
--- phpgwapi.org/templates/probusiness/navbar.inc.php	2004-11-06 16:34:27.000000000 +0100
+++ phpgwapi/templates/probusiness/navbar.inc.php	2005-09-30 20:44:37.581761600 +0200
@@ -107,15 +107,27 @@
 					lang('Current users') . ': ' . $GLOBALS['phpgw']->session->total() . '</a>';
 		}
 
+		if ($GLOBALS['phpgw']->acl->get_rights('changepassword','preferences') > 0)
+		{
 		if ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] == 0)
 		{
 			$api_messages = lang('You are required to change your password during your first login')
-				. '<br /> Click this image on the navbar: <img src="'
-				. $GLOBALS['phpgw']->common->image('preferences','navbar.gif').'">';
+                	     . '<br /> Click <a href="' . $GLOBALS['phpgw']->link('/preferences/changepassword.php') . '">here</a>';
+ 			}
+			else if ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] < time() - (86400*30))
+			{
+				$api_messages = lang('it has been more then %1 days since you changed your password',30)
+                	     . '<br /> Click <a href="' . $GLOBALS['phpgw']->link('/preferences/changepassword.php') . '">' . lang('here') . '</a>';
 		}
-		elseif ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] < time() - (86400*30))
+
+			if($api_messages)
 		{
-			$api_messages = lang('it has been more then %1 days since you changed your password',30);
+				$url = parse_url($GLOBALS['phpgw']->link('/preferences/changepassword.php'));
+				if($_SERVER['PHP_SELF'] != $url['path'])
+				{
+					$var['messages'] = $api_messages;
+				}
+			}
 		}
 
 		// This gonna change
diff -aburN --exclude='CVS*' phpgwapi.org/templates/verdilak/navbar.inc.php phpgwapi/templates/verdilak/navbar.inc.php
--- phpgwapi.org/templates/verdilak/navbar.inc.php	2004-11-06 16:34:26.000000000 +0100
+++ phpgwapi/templates/verdilak/navbar.inc.php	2005-09-30 20:44:37.521675200 +0200
@@ -103,15 +103,27 @@
 
 		// Maybe we should create a common function in the phpgw_accounts_shared.inc.php file
 		// to get rid of duplicate code.
+		if ($GLOBALS['phpgw']->acl->get_rights('changepassword','preferences') > 0)
+		{
 		if ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] == 0)
 		{
 			$api_messages = lang('You are required to change your password during your first login')
-                      . '<br /> Click this image on the navbar: <img src="'
-                      . $GLOBALS['phpgw']->common->image('preferences','navbar.gif').'">';
+                	     . '<br /> Click <a href="' . $GLOBALS['phpgw']->link('/preferences/changepassword.php') . '">here</a>';
 		}
 		else if ($GLOBALS['phpgw_info']['user']['lastpasswd_change'] < time() - (86400*30))
 		{
-			$api_messages = lang('it has been more then %1 days since you changed your password',30);
+				$api_messages = lang('it has been more then %1 days since you changed your password',30)
+                	     . '<br /> Click <a href="' . $GLOBALS['phpgw']->link('/preferences/changepassword.php') . '">' . lang('here') . '</a>';
+			}
+
+			if($api_messages)
+			{
+				$url = parse_url($GLOBALS['phpgw']->link('/preferences/changepassword.php'));
+				if($_SERVER['PHP_SELF'] != $url['path'])
+				{
+					$var['messages'] = $api_messages;
+				}
+			}
 		}
  
 		// This is gonna change